//****************************************************************
//    PIC18F14K50 M   <<5v >>    100_PulseGen_5v
//        Hi-Band   1.2MHz -  3KHz                    2011/06/24
//        Low-Band    2KHz - 1/8Hz
//        f[eBTCŃA5%Ƃɐݒł
//     1)Define I/O PORT
//         PORTB(4)pin13    :  SDA
//         PORTB(6)pin11    :  SCL
//         PORTB(7)pin10    :  Band SW fW^  (WPU ON)
//         PORTC(0)pin16    :  LED
//         AN 9(RC7)pin 9   :  VR AiO f[eBTCN
//         AN11(RB5)pin12   :  VR AiO g
//         CCP1(RC5)pin 5   :  Mo(_)
//         P1B (RC4)pin 6   :  Mo(_)
//     2)OSC
//         ONbN  12MHzOSC  PLL48MH 
//******************************************************/
//     Ԃ̎LED_
//******************************************************/
#include <p18f14k50.h>
#include <delays.h>
#include "lib_adc.h"
#include <timers.h>
#include <i2c.h>           //I2C֐
#include "lib_i2cLCD.h"    //I2CڑLCD֐
//-------------- ֐vg^Cv ------------------------
void DevicesIntlz (void);
void CCP_PWM(void);
void frq_PWM(void);
void itostr(unsigned long, char*, char);
void cutNoize(unsigned char);
void dutyPWM(void);
void CCP_Cmp(void);
void frq_Cmp(void);
void dutyCmp(void);
//-------------- RtBO[V ---------------------
#pragma config MCLRE  = OFF
#pragma config PWRTEN = OFF, BOREN  = OFF, BORV   = 30
#pragma config WDTEN  = OFF, WDTPS  = 32768
#pragma config STVREN = ON
#pragma config FOSC   = ECH //  ONbN
#pragma config PLLEN  = ON, CPUDIV = NOCLKDIV, USBDIV = OFF
#pragma config FCMEN  = OFF, IESO   = OFF, HFOFST = OFF
#pragma config LVP    = OFF, XINST  = OFF, BBSIZ  = OFF
#pragma config CP0    = OFF, CP1  = OFF, CPB  = OFF, CPD  = OFF
#pragma config WRT0   = OFF, WRT1 = OFF, WRTB = OFF, WRTC = OFF, WRTD = OFF
#pragma config EBTR0  = OFF, EBTR1 = OFF, EBTRB = OFF
//
#define BandSW     PORTBbits.RB7
#define signalOut  LATCbits.LATC5
#define LED        LATCbits.LATC0
// ----- 荞݃xNg -----
void isr_high(void);
#pragma interrupt isr_high
#pragma code h_int_vect = 0x0008
void _h_isr (void){
     _asm goto isr_high _endasm
}
#pragma code
// g萔 (Hi Band) ----------------------------------------------------------
    rom const unsigned int frqH[22]={3,5,6,10,12,15,20,30,40,50,
                    60,80,100,150,200,300,400,500,600,800,1000,1200};
    rom const unsigned char prT2[22]={249,149,124,74,249,199,149,99,74,59,
                    199,149,119,79,59,39,29,23,19,14,11,9};
    rom const unsigned char psT2[22]={16,16,16,16,4,4,4,4,4,4,
                    1,1,1,1,1,1,1,1,1,1,1,1};
// g萔 (LowBand) ----------------------------------------------------------
    rom const unsigned int frqL[]={-8,-5,-4,-2,1,2,3,4,5,6,8,10,20,30,40,50,60,
                    80,100,200,300,400,500,600,800,1000,2000};
    rom const unsigned int CCPR[]={59999,37499,29999,14999,7499,37499,24999,
                    18749,14999,12499,9374,59999,29999,19999,14999,11999,9999,
                    7499,5999,2999,1999,1499,1199,999,749,599,299};
    rom const unsigned char psT1[]={10,10,10,10,10,8,8,8,8,8,8,1,1,1,1,1,1,
                    1,1,1,1,1,1,1,1,1,1};
// ***** ʕϐ̒` *****
    char msgHz[]   ="      Hz ";
    char msgKHz[]  ="      KHz";
    char msgSlow[] ="  1/  Hz ";
    char msgFreq[] =" Freq";
    char msgPerC[] ="   %";
    char msgDuty[] =" Duty";
    unsigned char fqCmd;        // Ag
    unsigned char dcCmd;        // ADutyCycle
    unsigned char VRpos;        // VR position
    unsigned char bdCmd;        // g  Hi:1ALow:0
    unsigned char inCmd;        // ͎w
    unsigned char fqVRe;        // VR ҈ʒu  g
    unsigned char dcVRe;        // VR ҈ʒu  Duty
    unsigned char refsh = 1;    // \̍ĕ`
    unsigned char dcCnt = 0;    // C^vg̔
    unsigned char dcLow = 10;    // LowɂȂ^C~O
    unsigned char dcMax = 20;    // ɕKvȃC^vg
// ****** 荞ݏ ****************************
// dcCnt 20܂200łP
//    0             F v
//    1     - dcLow F HI
//    dcLow - dcMax F LOW
// ************************************************
void isr_high(){
    if (PIR1bits.CCP1IF == 1) {        // CCP̊荞݂
        PIR1bits.CCP1IF = 0;           // CCPtOOFF
        if(dcCnt == 0){                // MHIɂ
            Nop();Nop();Nop();         // ^C~O킹x
            Nop();Nop();
            LATC = 0b00100000;
        }else if(dcCnt == dcLow){      // MHIɂ
            LATC = 0b00010000;
        }
        if( ++dcCnt >= dcMax) dcCnt = 0; // I
    }
}
//*************** C֐   ***************
void main(void){
    PORTA = 0x00;
    PORTB = 0x00;
    PORTC = 0x00;
    TRISA = 0b11111111;           //PortA ׂē
    TRISB = 0b11111111;           //PortB ׂē
    TRISC = 0b11001110;           //PortC RC5(CCP1),RC4(P1B)͏o͓͑
    ANSEL  = 0b00000000;          //AN11AAN 9̓AiO  ̓fW^
    ANSELH = 0b00001010;          //    
    WPUA = 0b00000000;            //RB7Weak Pull Ups
    WPUB = 0b10000000;            //    
    INTCON2bits.NOT_RABPU = 0;    //    
    DevicesIntlz();               // foCX̏
    bdCmd = 1;                    // Hi Bandnɉݒ
    CCP_PWM();                    // CCPPWM[hɂ
    refsh = 1;                    // ăZbgs
// ---------------- LCD ݒ ---------------------
    LCD_int();                    // LCD
    LCD_str(msgFreq);             // LCDiɏl\
    LCD_posyx(1,0);               // LCD\ʒuw
    LCD_str(msgDuty);             // LCDiɏl\
    while(1){
        // ++++++++++ g mF ++++++++++
        inCmd = BandSW;
        if(bdCmd != inCmd){               // BandSW삳ꂽ
            LED = 1;                      // _
            bdCmd = inCmd;                // BandCommandύX
            refsh = 1;                    // ăZbgs
            if(bdCmd==1){                 // Hi Band Ȃ
                CCP_PWM();                    // CCPPWM[h
                INTCONbits.PEIE = 0;          // s
                INTCONbits.GIE = 0;
            }else{                        // Low Band Ȃ
                 CCP_Cmp();                    // CCPConpare[h
                INTCONbits.PEIE = 1;           // 
                INTCONbits.GIE = 1;
            }
        }
        // ++++++++++ g ݒ ++++++++++
        SetChanADC(ADC_CH11);            // gVRI
        ConvertADC();                    // ADϊJn
        while(BusyADC());                // ADϊI҂
        VRpos = ADRESH;                  // ADϊʎ擾
        cutNoize(fqVRe);                 // mCY
        if(bdCmd==1)frq_PWM();           // Hi Band  PWM[hŐݒ
        else frq_Cmp();                  // Low Band Conpare[hŐݒ
        
        // ++++++++++ f[eB ݒ ++++++++++
        SetChanADC(ADC_CH9);             // f[eBTCNVRI
        ConvertADC();                    // ADϊJn
        while(BusyADC());                // ADϊI҂
        VRpos = ADRESH;                  // ADϊʎ擾
        cutNoize(dcVRe);                 // mCŶ臒l牓
        inCmd = ((int)VRpos*19/256+1)*5; // DutyCyclěvZ
        if ((inCmd != dcCmd)||(refsh == 1)){ // -- ύXꂽ --
            LED = 1;                         // x_
            refsh = 0;                       // ăZbgFlag OFF
            dcCmd = inCmd;                   // DutyCycle̕ύX
            dcVRe = (int)(dcCmd/5-1)*256/19+8;  // w̒SVRʒuvZ
            // ---------  f[eBl\  ----------
            itostr(dcCmd, msgPerC, 2);      // l𕶎ɕϊ
            LCD_posyx(1,9);                 // LCD\ʒuw
            LCD_str(msgPerC);               // \
                if(bdCmd==1)dutyPWM();        // Hi Band  PWM[hŐݒ
                else dutyCmp();               // Low Band Conpare[hŐݒ
        }
        // ++++++++++++++++++++++++++++++
            LED = 0;                        // x
    };
}
//********** f[eBTCN̐ݒ PWM *******
void dutyPWM(){
    unsigned int dutyReg;
    dutyReg = ((int)prT2[fqCmd]+1) << 2;        // PR2擾
    dutyReg = (long)dutyReg * dcCmd/100;        // CCP̐ݒlvZ
    CCP1CONbits.DC1B0 = dutyReg & 1;            // ʂQrbg̐ݒ
    CCP1CONbits.DC1B1 = (dutyReg >> 1) & 1;     //     
    CCPR1L = dutyReg >> 2;                      // ʂWrbg̐ݒ
}
//************  f[eBTCNݒ Cmpare *****
void dutyCmp(void){
        if (psT1[fqCmd] > 8){    // psT1W𒴂ꍇ
            dcLow = dcCmd * 2;    // C^vg200łP
            dcMax = 200;
        }else{                    // ȊO 
            dcLow = dcCmd / 5;    // C^vg 20łP
            dcMax = 20;
        }
}
//****** 𕶎ɕϊ֐  ([TvXj******** 
//  num     ϊ鐮
//  strAdd  ϊʂ̊i[镶
//  digit   ϊ镶
//************************************************************
void itostr(unsigned long num, char *strAdd, char digit){
    char i;    
    char flag=1;                   //[TvX Flag
    char coma=0;                   //R} Flag    
    strAdd += digit;               // ̍Ō
    for(i=digit; i>0; i--) {       // ʌ珈
        strAdd--;                  // P
        if (flag == 1){        
            if (coma++ == 3){      //R} ̈ʒu    
                *strAdd = ',';           //R} i[    
                coma=0;
            }else{                 // P̐l𕶎Ŋi[
                *strAdd = (num % 10) + 0x30;
                num = num / 10;         // ̏
                if (num == 0) flag=0;   // [Ȃȍ~͗}
            }
        }else{                     // ʂ̂O͗}
            *strAdd = 0x20;        // ȎɃXy[Xi[
        }
    }
}
// ************ CCP ݒ PWM ***********
void CCP_PWM(void){
    PIE1bits.CCP1IE = 0;   // 荞݂gpȂB
    PIR1bits.CCP1IF = 0;
    PSTRCON = 0b00000011;  // PWMo͂P1A P1Bs
    CCPR1L  = 0x7E;        // ̒l
    CCP1CON = 0b00001101;  // PWM[hASingle OutputAP1A: P1B:
}
// ************ CCP ݒ Compare ***********
void CCP_Cmp(void){
    CCP1CON = 0b00001011;  // Compare [hspecial event
    CCPR1L = 0xFF;         // ̒l
    CCPR1H = 0xFF;         // 
    PIE1bits.CCP1IE = 1;   // 荞݂gpB
    PIR1bits.CCP1IF = 0;
}
// ************ foCX ***********
void DevicesIntlz(void){
// -------------------- I2C ݒ ---------------------    
    OpenI2C(MASTER, SLEW_ON);       //I2C}X^[[hw
    SSPADD = 0x1D;                  //Board Rate 400kHz
// -------------------- ADC ݒ ---------------------    
    OpenADC(ADC_FOSC_64 &
            ADC_LEFT_JUST &
            ADC_12_TAD, 
            ADC_REF_VDD_VDD &
            ADC_REF_VDD_VSS, 
            ADC_CH11 &
            ADC_INT_OFF );
// -------------------- Timer 1 ݒ ---------------------
    OpenTimer1(            
        TIMER_INT_OFF &
        T1_8BIT_RW &
        T1_SOURCE_INT &
        T1_PS_1_8 &
        T1_OSC1EN_OFF &
        T1_SOURCE_CCP );
    PIR1bits.TMR1IF = 0;
    TMR1H = 0;
    TMR1L = 0;
// -------------------- Timer 2 ݒ ---------------------
    OpenTimer2(    
        TIMER_INT_OFF &
        T2_PS_1_4 &
        T2_POST_1_1 );
    PIR1bits.TMR2IF = 0;
    TMR2 = 0;
    PR2 = 0xFF;
}
//******************************************
// ADϊ̃mCYŁAR}hϓȂ悤
// ADϊlR}hSlɋ߂Â
//******************************************
void cutNoize(unsigned char VRexp){
    if(VRpos > VRexp){
        if(VRpos > 2) VRpos -= 2;
    }else{
        if(VRpos < 0xFE) VRpos += 2;
    }
}
//******** PWM gݒ *******************
void frq_PWM(void){
    inCmd = ((int)VRpos * 22)/256;        // gԍ̌vZ
    if ((inCmd != fqCmd)||(refsh == 1)){  // -- ύXꂽ --
        LED = 1;                            // x_
        fqCmd = inCmd;                      // gԍ̕ύX
        fqVRe = fqCmd*256/22+5;             // w̒SVRʒuvZ
        itostr(frqH[fqCmd], msgKHz, 5);     // \g̎擾
        LCD_posyx(0,6);                     // LCD\ʒuw
        LCD_str(msgKHz);                    // LCDiɎg
        switch (psT2[fqCmd]){               // vXP̐ݒ
            case 1: T2CON = 0b00000100;break;    //  x1
            case 4: T2CON = 0b00000101;break;    //  x4
            default:T2CON = 0b00000111;          //  x16
        }
        PR2 = prT2[fqCmd];                // vZbg̐ݒ
        dutyPWM();                        // DutyCycle̍XV
    }
}
//******** Compare gݒ *******************
void frq_Cmp(void){
    int fqDsp;
    inCmd = ((int)VRpos * 27)/256;        // gԍ̌vZ
    if ((inCmd != fqCmd)||(refsh == 1)){  // -- ύXꂽ --
        LED = 1;                            // x_
        fqCmd=inCmd;                        // gԍ̕ύX
        fqVRe = fqCmd*256/27+5;             // w̒SVRʒuvZ
        fqDsp = frqL[fqCmd];                // ---- g̕\ ---- 
        LCD_posyx(0,6);                     // LCD\ʒuw
        if(fqDsp<0){                        // 1Hz̎g
            fqDsp = - fqDsp;                    // 1Hz͕Ŏ
            itostr(fqDsp, msgSlow+4, 1);        // \
            LCD_str(msgSlow);
        }else{                              // PHzȏ̎g
            itostr(fqDsp, msgHz, 5);            // \g̎擾
            LCD_str(msgHz);                     // \
        }
                                            // vXP̐ݒ
        if (psT1[fqCmd]==1)T1CON = 0b00000001;        //  x1
            else           T1CON = 0b00110001;        //  x8
        CCPR1H = CCPR[fqCmd] >> 8;            // CCPvZbg̐ݒ 
        CCPR1L = CCPR[fqCmd] & 0xFF;
        dutyCmp();                            //  Duty̐ݒ 
    }
}
// --- Copyright (C) 2011-2012 Kazuo Iwamoto All Rights Reserved. ---
